%==========================================================================
% Aircraft Physical Paramters
% Reference: S. B. Buttrill and P. D. Arbuckle  and K. D. Hoffler
%            Simulation model of a twin-tail, high performance airplane
%            NASA 1992, NASA TM-107601


S = 400;                % ft^2
b =  37.42;             % ft
c =  11.52;             % ft
rho = 1.0660e-003;      % slugs/ft^3  --- 25C / 25000 ft
Ixx = 23000;            % slugs*ft^2
Iyy = 151293;           % slugs*ft^2 
Izz = 169945;           % slugs*ft^2 
Ixz = - 2971;           % slugs*ft^2
m = 1034.5;             % slugs
g = 32.2;               % ft/s^2

% Unit Conversion : Degree <--> Radian
d2r = pi/180;
r2d = 1/d2r;


V       = 250 ;              % Airspeed Assumed to be constant at 250 ft/s;





