%
% This File Generates Closed Loop Plants for Different Flight Conditions. 
%

%-----------------------------------
% Load data 
f18_data; 



%==========================================================================
% Genearte Closed Loop Linear Plants


%-------------------------------------------------
% PLANT 1: 
% Load Plant at alpha = 0 degree and beta = -12 degree

Pdata = load('LinF18OloopBeta12mAlpha0'); 


% Generate Closed Loop Plant around the specified flight condition
disp('==========================================================')
disp('Plant : alpha = 0 degree and beta = -12 degree')
disp('==========================================================')
Gen_LinF18Clps; 

% Rename open Loop Plants
Pss_Baseline_Beta12mAlpha0 = Pss_Baseline; 
Pss_Revised_Beta12mAlpha0  = Pss_Revised; 




%-------------------------------------------------
% PLANT 2: 
% Load Plant at alpha = -5 degree and beta = 5 degree

Pdata = load('LinF18OloopBeta5Alpha5m'); 


% Generate Closed Loop Plant around the specified flight condition
disp('==========================================================')
disp('Plant : alpha = -5 degree and beta = 5 degree')
disp('==========================================================')
Gen_LinF18Clps; 

% Rename Open Loop Plants
Pss_Baseline_Beta5Alpha5m  = Pss_Baseline; 
Pss_Revised_Beta5Alpha5m  = Pss_Revised; 


%-------------------------------------------------
% PLANT 3: 
% Load Plant at alpha = 0 degree and beta = 3 degree

Pdata = load('LinF18OloopBeta3Alpha0'); 


% Generate Closed Loop Plant around the specified flight condition
disp('==========================================================')
disp('Plant : alpha = 0 degree and beta = 3 degree')
disp('==========================================================')
Gen_LinF18Clps; 

% Rename open Loop Plants
Pss_Baseline_Beta3Alpha0 = Pss_Baseline; 
Pss_Revised_Beta3Alpha0  = Pss_Revised; 


%-------------------------------------------------
% PLANT 4: 
% Load Plant at alpha = 0 degree and beta = -3 degree

Pdata = load('LinF18OloopBeta3mAlpha0'); 


% Generate Closed Loop Plant around the specified flight condition
disp('==========================================================')
disp('Plant : alpha = 0 degree and beta = -3 degree')
disp('==========================================================')
Gen_LinF18Clps; 

% Rename Open Loop Plants
Pss_Baseline_Beta0Alpha10m = Pss_Baseline; 
Pss_Revised_Beta0Alpha10m  = Pss_Revised; 




%-------------------------------------------------
% PLANT 5: 
% Load Plant at alpha = 0 degree and beta = 0 degree

Pdata = load('LinF18OloopBeta0Alpha0'); 


% Generate Closed Loop Plant around the specified flight condition
disp('==========================================================')
disp('Plant : alpha = 0 degree and beta = 0 degree')
disp('==========================================================')
Gen_LinF18Clps; 

% Rename open Loop Plants
Pss_Baseline_Beta0Alpha0 = Pss_Baseline; 
Pss_Revised_Beta0Alpha0  = Pss_Revised; 


%-------------------------------------------------
% PLANT 6: 
% Load Plant at alpha = 10 degree and beta = 0 degree

Pdata = load('LinF18OloopBeta0Alpha10'); 


% Generate Closed Loop Plant around the specified flight condition
disp('==========================================================')
disp('Plant : alpha = 10 degree and beta = 0 degree')
disp('==========================================================')
Gen_LinF18Clps; 

% Rename Closed Loop Plants
Pss_Baseline_Beta0Alpha10 = Pss_Baseline; 
Pss_Revised_Beta0Alpha10  = Pss_Revised; 




%-------------------------------------------------
% PLANT 7: 
% Load Plant at alpha = 10 degree and beta = 3 degree

Pdata = load('LinF18OloopBeta3Alpha10'); 


% Generate Closed Loop Plant around the specified flight condition
disp('==========================================================')
disp('Plant : alpha = 10 degree and beta = 3 degree')
disp('==========================================================')
Gen_LinF18Clps; 

% Rename Closed Loop Plants
Pss_Baseline_Beta3Alpha10 = Pss_Baseline; 
Pss_Revised_Beta3Alpha10  = Pss_Revised; 




%-------------------------------------------------
% PLANT 8: 
% Load Plant at alpha = 0 degree and beta = -3 degree

Pdata = load('LinF18OloopBeta3mAlpha0'); 


% Generate Closed Loop Plant around the specified flight condition
disp('==========================================================')
disp('Plant : alpha = 0 degree and beta = -3 degree')
disp('==========================================================')
Gen_LinF18Clps; 

% Rename Closed Loop Plants
Pss_Baseline_Beta3mAlpha0 = Pss_Baseline; 
Pss_Revised_Beta3mAlpha0  = Pss_Revised; 


%-------------------------------------------------
% PLANT 9: 
% Load Plant at alpha = 0 degree and beta = 3 degree

Pdata = load('LinF18OloopBeta3Alpha0'); 


% Generate Closed Loop Plant around the specified flight condition
disp('==========================================================')
disp('Plant : alpha = 0 degree and beta = 3 degree')
disp('==========================================================')
Gen_LinF18Clps; 

% Rename Closed Loop Plants
Pss_Baseline_Beta3Alpha0 = Pss_Baseline; 
Pss_Revised_Beta3Alpha0  = Pss_Revised; 



%-------------------------------------------------
% PLANT 8: 
% Load Plant at alpha = 6 degree and beta = -2 degree

Pdata = load('LinF18OloopBeta2mAlpha6'); 


% Generate Closed Loop Plant around the specified flight condition
disp('==========================================================')
disp('Plant : alpha = 6 degree and beta = -2 degree')
disp('==========================================================')
Gen_LinF18Clps; 

% Rename Closed Loop Plants
Pss_Baseline_Beta2mAlpha6 = Pss_Baseline; 
Pss_Revised_Beta2mAlpha6  = Pss_Revised; 


%-------------------------------------------------
% PLANT 9: 
% Load Plant at alpha = 6 degree and beta = 2 degree

Pdata = load('LinF18OloopBeta2Alpha6'); 


% Generate Closed Loop Plant around the specified flight condition
disp('==========================================================')
disp('Plant : alpha = 6 degree and beta = 2 degree')
disp('==========================================================')
Gen_LinF18Clps; 

% Rename Closed Loop Plants
Pss_Baseline_Beta2Alpha6 = Pss_Baseline; 
Pss_Revised_Beta2Alpha6  = Pss_Revised; 

