%% Example (E7) from the paper (*)
% (*) Topcu, Packard, Seiler, "Local stability analysis using simulations
% and sum-of-squares programming," Automatica, 2008. 


%% 
% Form the vector field
pvar x1 x2; 
x=[x1;x2];
f=[-0.42*x(1)-1.05*x(2)-2.3*x(1)^2-0.5*x(1)*x(2)-x(1)^3;1.98*x(1)+x(1)*x(2)];  

%%
% p, the basis vector for V and the iteration options (if not equal
% to the default values) need to be specified before generating the options
% structures
p = x'*[29.8951 0.77567/2;0.77567/2 15.727]*x;
zV = monomials(x,2:4);
Bis.flag = 0;
Bis.r1deg = 4;


%%
% Generate the options
[roaconstr,opt,sys] = GetRoaOpts(f, x, zV, p, Bis);
%%
% Modify the options 
opt.coordoptim.IterStopTol = 1e-5;
opt.display.roaest = 1;

%%
% Solve the problem
outputs = wrapper(sys,[],roaconstr,opt);
%%
% Extract the solution 
[V,beta,gamma,p,multip,betaUpper] = extractSol(outputs);
%%
beta
%%
betaUpper

[vol,volstd] = pvolume(V,gamma,[],10000);
%% 
% Volume of the ROA estimate
Volume = vol/pi









