function  [L,U] = PolyCoverNew(DelVert,d,g)

m = length(DelVert)/2;
cc = reshape(DelVert,2,m);

if 1
    % XXX PJS 5/21/2009 Updated to sossopt
    for i1 = 1:length(g)
        uncf = g(i1); 
        whichd = LOCALWhichOfd(uncf,d);
        ind = find(whichd==1);
        maxdeg = full(max(max(uncf.deg)));
        degs = maxdeg - 2;
        if ~(floor(degs/2)==ceil(degs/2))%~even(degs) 
            degs = degs + 1; 
        end
        u = cc(2,ind)';
        l = cc(1,ind)';
        
        %%upper bound computation
        a = mpvar('a',length(ind),1);
        pvar b
        cost = LOCALgetintegral(cc,ind,a,b);
        expr = -uncf + a'*d(ind) + b; 
        s = cell(length(ind),1);
        for i2 = 1:length(ind)
            s{i2} = polydecvar('s',monomials(d(ind), 0:degs),'mat');
            expr = expr - s{i2}*(u(i2) - d(ind(i2)))*(d(ind(i2))-l(i2));
        end
        ineq = [s; {expr}];
        obj = cost;
        opts = [];
        [info,dopt]=sosopt(ineq,d(ind),obj,[],opts);
        U(:,i1) = zeros(m+1,1);
        U(ind,i1) = double(subs(a,dopt(:,1),dopt(:,2)));
        U(end,i1) = double(subs(b,dopt(:,1),dopt(:,2)));
            
        
        %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
        %%lower bound
        %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
        a = mpvar('a',length(ind),1);
        cost = LOCALgetintegral(cc,ind,a,b);
        expr = uncf - a'*d(ind) - b;
        s = cell(length(ind),1);
        for i2 = 1:length(ind)
            s{i2} = polydecvar('s',monomials(d(ind), 0:degs),'mat');
            expr = expr - s{i2}*(u(i2) - d(ind(i2)))*(d(ind(i2))-l(i2));
        end
        ineq = [s; {expr}];
        obj = -cost;
        opts = [];
        [info,dopt]=sosopt(ineq,d(ind),obj,[],opts);
        L(:,i1) = zeros(m+1,1);
        L(ind,i1) = double(subs(a,dopt(:,1),dopt(:,2)));
        L(end,i1) = double(subs(b,dopt(:,1),dopt(:,2)));
    end

    
else
    % Original Code
    for i1 = 1:length(g)
        uncf = g(i1); 
        whichd = LOCALWhichOfd(uncf,d);
        ind = find(whichd==1);
        maxdeg = full(max(max(uncf.deg)));
        degs = maxdeg - 2;
        if ~even(degs) degs = degs + 1; end
        u = cc(2,ind)';
        l = cc(1,ind)';
        %%upper bound computation
        for i2 = 1: length(ind)
            varname = {['a' int2str(i2)]};
            coef = 1;
            matdim = [ 1 1];
            deg = 1;
            a(i2,1) = polynomial(coef,deg,varname,matdim);     
        end
        pvar b
        prog = sosprogram(d(ind),[a;b]);
        cost = LOCALgetintegral(cc,ind,a,b);
        expr = -uncf + a'*d(ind) + b;
        for i2 = 1:length(ind)
            [prog,s(i2)] = sossosvar(prog, monomials(d(ind), 0:degs));
            expr = expr - s(i2)*(u(i2) - d(ind(i2)))*(d(ind(i2))-l(i2));
        end
        prog = sosineq(prog,expr);
        prog = sossetobj(prog, cost);
        [prog,info] = sossolve(prog);
        U(:,i1) = (zeros(m+1,1));
        try
            U(ind,i1) = LOCALgeta(prog,a,ind);
        catch
            keyboard
        end
        U(end,i1) = double(sosgetsol(prog,b));   

        clear prog a b s expr
        %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
        %%lower bound
        %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
        for i2 = 1: length(ind)
            varname = {['a' int2str(i2)]};
            coef = 1;
            matdim = [ 1 1];
            deg = 1;
            a(i2,1) = polynomial(coef,deg,varname,matdim);     
        end
        pvar b
        prog = sosprogram(d(ind),[a;b]);
        cost = LOCALgetintegral(cc,ind,a,b);
        expr = uncf - a'*d(ind) - b;
        for i2 = 1:length(ind)
            [prog,s(i2)] = sossosvar(prog, monomials(d(ind), 0:degs));
            expr = expr - s(i2)*(u(i2) - d(ind(i2)))*(d(ind(i2))-l(i2));
        end
        prog = sosineq(prog,expr);
        prog = sossetobj(prog, -cost);
        [prog,info] = sossolve(prog);
        L(:,i1) = (zeros(m+1,1));
        L(ind,i1) = LOCALgeta(prog,a,ind);  
        L(end,i1) = double(sosgetsol(prog,b)); 


        clear prog a b s expr
    end
end


%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

function a = LOCALgeta(prog,a,ind)
aaux = zeros(size(a));
 for i2 = 1:length(ind)
     % XXX PJS 5/20/2009 Updated polynomial to allow cell string inputs 
     %aaux(i2,1) = double(sosgetsol(prog,polynomial(1,1,{['a' int2str(i2)]},[1 1])));
     aaux(i2,1) = double(sosgetsol(prog,polynomial({['a' int2str(i2)]})));
 end
 clear a
 a = aaux;
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
function intt = LOCALgetintegral(cc,ind,a,b)
u = cc(2,ind);
l = cc(1,ind);

intt = 0;
for i1 = 1:length(ind)
    fff = 1;
    for i2 = 1:length(ind)
        if i2 ~= i1
            fff = fff*(u(i2)-l(i2));
        end
    end
    intt = intt + 0.5*a(i1)*(u(i1)^2-l(i1)^2)*fff;
end
intt = intt + b*fff*(u(end)-l(end));

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%5

function vec = LOCALWhichOfd(g,d)

vec = zeros(length(d),1);
for i1 = 1:length(d)
    if ismember(d(i1).varname,g.varname)
        vec(i1) = 1;
    end
end


