function info = RunIterations(V, Gamma0, Beta0, fList, XList, roaconstr, opt, info)

d = opt.display.roaest;
MaxIters = opt.coordoptim.MaxIters;
IterStopTol = opt.coordoptim.IterStopTol;

Gamma = Gamma0;
Beta = Beta0;


tic
i1 = 1;
BetaLB = Beta;
BetaInc = 10;
VLB = polynomial(0);


if opt.coordoptim.flag
   S1 = info.preIterBest.beta.S1;
   S2 = info.preIterBest.gamma.S2;
   S3 = info.preIterBest.gamma.S3;
else
    r1 = info.preIterBest.gamma.r1;
    r2 = info.preIterBest.beta.r2;
end

iteration(1).getnewV = [];
iteration(1).getgamma = [];
iteration(1).getbeta = [];

while (i1 <=MaxIters) & (BetaInc > IterStopTol)
    BetaBase = Beta;
    if d
        fprintf('-------------------Iteration = %d \n', i1);
    end
    
    if opt.coordoptim.flag
        Vinfo = getNewV(fList, XList, S1, S2, S3, roaconstr, Gamma, Beta);
    else
        Vinfo = getNewV_Affine(r1, r2, Gamma, fList, XList, roaconstr, opt, Beta);
    end
    V = Vinfo.V; Beta = double(Vinfo.Beta); Gamma = double(Vinfo.Gamma);
        
    if opt.coordoptim.flag
        ginfo = getgamma(V,fList, XList, roaconstr, opt.getgamma); 
        S2=ginfo.S2; S3=ginfo.S3;
    else
        ginfo = getgamma_Affine(V, fList, XList, roaconstr, opt, Gamma);
        r1 = ginfo.r1;
    end
    
    Gamma1 = double(ginfo.Gamma); 
    
    if opt.coordoptim.flag
        binfo.S1 = polynomial(0);
    else
        binfo.r2 = polynomial(0);
    end
    binfo.Beta = 0;
    Beta1 = 0;
    
    if Gamma1 > 0
%         if d
%             fprintf('\n getbeta \n');
%         end
        if opt.coordoptim.flag
            binfo = getbeta(V, Gamma1, XList, roaconstr, opt.getbeta);
            S1 = binfo.S1;
        else
            binfo.r2 = polynomial(0);
            binfo = getbeta_Affine(V, Gamma1, XList, roaconstr, opt, Beta1);
            r2 = binfo.r2;
        end
        Beta1 = double(binfo.Beta);  
    end
    
    
    iteration(i1).getnewV = Vinfo;
    iteration(i1).getgamma = ginfo;
    iteration(i1).getbeta = binfo;
    
    BetaInc = double(Beta1)-double(BetaBase);
    if BetaInc > 0
        VLB = V;
        BetaLB = double(Beta1);
        Beta = double(Beta1);
        Gamma = double(Gamma1);
    end
    if d
       fprintf('Beta = %4.3f (Gamma = %4.3f) \n',Beta,Gamma);
    end

    i1 = i1 + 1;
end

info.iteration = iteration;
info.CPUTimeIter = toc;
info.BetaBnds = [opt.getbeta.maxbeta BetaLB];
info.V = VLB;

        
