function [isfeasp, beta, rout] = VcontainP_Affine(V , x, zr, p, Gamma, opt, BetaCurrent)

solver = opt.coordoptim.solver;
% % backOffFactor = opt.getbeta.backOffFactor;

if 1
    % XXX PJS 5/21/2009 Updated to sossopt
    opts.solver = solver;
    pvar b
    obj = -b;

    r = polydecvar('r',zr,'vec');

    degzr = max(max(zr.degmat));
    degp = max(max(p.degmat));
    degV = max(max(V.degmat));
    d = full(ceil((degV+degzr-degp)/2));

    ineq{1} = (p-b)*sum(x.^(2*d))-(V-Gamma)*r;
    %ineq{2} = BetaCurrent - b;
    [info,dopt]=sosopt(ineq,x,obj,[],opts);
    isfeasp = info.feas;

    rout = polynomial(0);
    beta = BetaCurrent;    
    if isfeasp
        beta = double( subs(b,dopt(:,1),dopt(:,2)) );
        rout = subs(r,dopt(:,1),dopt(:,2));                
    elseif BetaCurrent > 0
        beta = BetaCurrent;
        obj = [];
        [info,dopt]=sosopt(ineq(1),x,obj,[],opts);
        rout = subs(r,dopt(:,1),dopt(:,2));        
        isfeasp = info.feas;
    end

else
    % Original Code
    pvar b
    prog = sosprogram(x,b);

    [prog,r] = sospolyvar(prog,zr);


    degzr = max(max(zr.degmat));
    degp = max(max(p.degmat));
    degV = max(max(V.degmat));
    d = full(ceil((degV+degzr-degp)/2));

    ineq = (p-b)*sum(x.^(2*d))-(V-Gamma)*r;
    prog = sosineq(prog,[ineq]);

    pprog = sosineq(prog, BetaCurrent - b);

    prog = sossetobj(prog,-b);

    [prog,info] = sossolve(prog,[],[],solver);
    isfeasp = double(check_feasp(info,solver)==1);

    beta = BetaCurrent;
    rout = [];

    if isfeasp
        beta = double(sosgetsol(prog,b));
        rout = sosgetsol(prog, r);
    elseif BetaCurrent > 0
        beta = BetaCurrent;
        clear prog
        prog = sosprogram(x);
        [prog,r] = sospolyvar(prog,zr);
        ineq = (p-b)*sum(x.^(2*d))-(V-Gamma)*r;
        prog = sosineq(prog,[ineq]);
        [prog,info] = sossolve(prog,[],[],solver);
        isfeasp = double(check_feasp(info,solver)==1);
        rout = sosgetsol(prog, r);
    end
end

