function [BetaOut,VOut,GammaOut, UpBOut, NominalBetaOut,infoOut] =...
    cellBetaCenter(fNOM,fVER,XList, roaconstr, opt, prior)

m = length(fNOM);
BetaOut = zeros(m,1);
NominalBetaOut = zeros(m,1);
for i1 = 1:m
    VOut(i1,1) = polynomial(0);
end

GammaOut = zeros(m,1);
UpBOut = inf*ones(m,1);
for i1 = 1:m
    Vprior(i1,1) = polynomial(0);
    Betaprior(i1,1) = 0;
    Gammaprior(i1,1) = 0;
end

if nargin == 6
    if ~isempty(prior)
        for i7 = 1:m
            Vprior(i7,1) = prior(i7).V;
            Betaprior(i7,1) = prior(i7).Beta;
            Gammaprior(i7,1) = prior(i7).Gamma;
        end
    end
end

VPRIOR = Vprior; BetaPRIOR = Betaprior; GammaPRIOR = Gammaprior;

clear Vprior Betaprior Gammaprior



%--------------------------------------------------------------------------

for i8 = 1:m
    fnom = fNOM{i8};
    fver = fVER{i8};
    Vprior = VPRIOR(i8);
    Betaprior = BetaPRIOR(i8);
    Gammaprior = GammaPRIOR(i8);
    opt.getgamma.maxgamma = opt.getgamma.maxgammaBase;
    
    info.nominalinfo = [];
    info.IterInfo = [];
    
    if 1 %Vprior == polynomial(0)
        if opt.display.roaest
            fprintf('No Prior V - Sim Based Analysis \n');
        end
        S1 = []; S2 = []; S3 = []; r1 = []; r2 = [];
        [BetaBnds_nom, V, info_nom] = RoaEst(fnom, XList, roaconstr, opt, fver);
        info.nominalinfo = info_nom;
        Bnom = info_nom.BetaBnds(2);    
    else
        if opt.display.roaest
            fprintf('Check the prior V \n');
        end
        V = Vprior;
        if opt.coordoptim.flag
            ginfo = getgamma(V,fnom, XList, roaconstr, opt.getgamma);
            S2=ginfo.S2; S3=ginfo.S3;
            Gnom = ginfo.Gamma;
        else
            ginfo = getgamma_Affine(V,fnom, XList, roaconstr, opt,0);
            r1 = ginfo.r1;
            Gnom = ginfo.Gamma;
        end
        Bnom = 0; S1 = []; r2 = [];
        if Gnom > 0
            if opt.coordoptim.flag
                binfo = getbeta(V, Gnom, XList, roaconstr,opt.getbeta);
                S1 = binfo.S1;
            else
                binfo = getbeta_Affine(V, Gnom, XList, roaconstr, opt, 0);
                r2 = binfo.r2;
            end
            Bnom = binfo.Beta;
            if opt.coordoptim.flag
                infoAux.preIterBest.beta.S1 = S1;
                infoAux.preIterBest.gamma.S2 = S2;
                infoAux.preIterBest.gamma.S3 = S3;
            else
                infoAux.preIterBest.gamma.r1 = r1;
                infoAux.preIterBest.beta.r2 = r2;
            end
        end
        
        if Bnom < opt.BB.FactorNomSimCellBeta*opt.sim.BetaInit
            if opt.display.roaest
                fprintf('Prior V is not so good, run sim based analysis \n');
            end
            opt1 = opt;
            opt1.coordoptim.MaxIters = 1;
            [BetaBnds_nom, VAux, info_nom] = RoaEst(fnom, XList, roaconstr, opt1, fver);
            info.nominalinfo = info_nom;
            BnomAux = BetaBnds_nom(2);
            if BnomAux > opt.BB.FactorNomStartPriorCellBeta*Betaprior
                if opt.display.roaest
                    fprintf('Sim based V is better than prior V - run iterations \n');
                end
                Bnom = BnomAux;
                V = VAux;
                Gnom = info_nom.iteration(end).getgamma.Gamma;
                if opt.coordoptim.flag
                    infoAux.preIterBest.beta.S1 = info_nom.iteration(end).getbeta.S1;
                    infoAux.preIterBest.gamma.S2 = info_nom.iteration(end).getgamma.S2;
                    infoAux.preIterBest.gamma.S3 = info_nom.iteration(end).getgamma.S3;
                else
                    infoAux.preIterBest.gamma.r1 = info_nom.iteration(end).getgamma.r1;
                    infoAux.preIterBest.beta.r2 = info_nom.iteration(end).getbeta.r2;
                end
            end
        end
        if Bnom > 0
            IterInfo = RunIterations(V, Gnom, Bnom, fnom, XList, roaconstr, opt,infoAux);
            info.IterInfo = IterInfo;
            Bnom = IterInfo.BetaBnds(2);
            V = IterInfo.V;
        end
    end
    
    [contain,order] = fNOMcontainfVER(fNOM{i8},fVER{i8});
    if contain
        if opt.coordoptim.flag
            S1 = info.nominalinfo.iteration(end).getbeta.S1;
            S2 = info.nominalinfo.iteration(end).getgamma.S2(order);
            S3 = info.nominalinfo.iteration(end).getgamma.S3(order);
        else
            r1 = info.nominalinfo.iteration(end).getgamma.r1(order);
            r2 = info.nominalinfo.iteration(end).getbeta.r2;
        end
        Gver = info.nominalinfo.iteration(end).getgamma.Gamma;
        Bver = info.nominalinfo.iteration(end).getbeta.Beta;
    else

        Gver = 0; S2 = []; S3 = []; r1 = [];
        if Bnom == 0
            Bver = 0;
            Gver = 0;
            V = polynomial(0);
        else
            if opt.display.roaest
                fprintf('Verify at the vertices \n');
            end
            if opt.coordoptim.flag
                ginfo = getgamma(V,fver, XList, roaconstr, opt.getgamma);
                S2=ginfo.S2; S3=ginfo.S3;
                Gver = ginfo.Gamma;
            else
                ginfo = getgamma_Affine(V,fver, XList, roaconstr, opt,0);
                r1 = ginfo.r1;
                Gver = ginfo.Gamma;
            end
            Bver = 0 ; r2 = []; S1 = [];
            if Gver > 0
                if opt.coordoptim.flag
                    binfo = getbeta(V, Gver, XList, roaconstr,opt.getbeta);
                    S1 = binfo.S1;
                else
                    binfo = getbeta_Affine(V, Gver, XList, roaconstr, opt, 0);
                    r2 = binfo.r2;
                end
                Bver = binfo.Beta;
            end
        end
    end
    
    if Bver < Betaprior
        if opt.display.roaest
            fprintf('New V is not as good as prior Beta \n');
            fprintf('Verify the prior V for the new cell \n');
        end
        Bnom = inf;
        V = Vprior;
        if opt.coordoptim.flag
            ginfo = getgamma(V,fver, XList, roaconstr, opt.getgamma);
            S2=ginfo.S2; S3=ginfo.S3;
            Gver = ginfo.Gamma;
        else
            ginfo = getgamma_Affine(V,fver, XList, roaconstr, opt,0);
            r1 = ginfo.r1;
            Gver = ginfo.Gamma;
        end;
        Bver = 0 ; r2 = []; S1 = [];
        if Gver > 0
            if opt.coordoptim.flag
                binfo = getbeta(V, Gver, XList, roaconstr,opt.getbeta);
                S1 = binfo.S1;
            else
                binfo = getbeta_Affine(V, Gver, XList, roaconstr, opt, 0);
                r2 = binfo.r2;
            end
            Bver = binfo.Beta;
        end
    end
    
    if opt.coordoptim.flag
        info.S1 = S1;
        info.S2 = S2;
        info.S3 = S3;
    else
        info.r1 = r1;
        info.r2 = r2;
    end
    info.fNOM = fNOM;
    info.fVER = fVER;
    info.V = V;
    info.Beta = Bver;
    info.Gamma = Gver;
    BetaOut(i8,1) = info.Beta;
    GammaOut(i8,1) = info.Gamma;
    infoOut(i8,1) = info;
    NominalBetaOut(i8,1) = Bnom;
    VOut(i8,1) = V;
    UpBOut(i8,1) = info.nominalinfo.BetaBnds(1);
    if opt.display.roaest
        fprintf('-------------------Robust results: \n');
        fprintf('Nominal Beta = %4.3f;  Robust Beta = %4.3f) \n',Bnom,Bver);
    end
end
    
    
    
    
    
    
    
