function [Beta_vec, Gamma_vec, Vvec, UpB_vec, Active, Mcell, NominalBetaVec, fnom, fver, prior] =...
        getNewCells(Beta_vec, Gamma_vec, Mcell, Vvec, UpB_vec, Active, NominalBetaVec, opt, sys, IterCount);
     
crsizeMcell = size(Mcell,1); 
    
     
[m,newCellNumber] = feval(opt.BB.SubdivisionRule);

%%%%%%%%
Ncomp = sum(newCellNumber);
%%%%%%%%

ActiveIdx = find(Active);
[betamin, ind] = sort(Beta_vec(ActiveIdx));
ind = ActiveIdx(ind(1:m));
Active(ind) = 0;


for i1 = 1:m
    Active = [Active;ones(newCellNumber(i1),1)];
%     Vvec = [Vvec; repmat(Vvec(ind(i1)),newCellNumber(i1),1)];
    Vvec(length(Vvec)+1:length(Vvec)+newCellNumber(i1),1) = Vvec(ind(i1));
    Beta_vec = [Beta_vec ; Beta_vec(ind(i1))*ones(newCellNumber(i1),1)];
    Gamma_vec = [Gamma_vec; Gamma_vec(ind(i1))*ones(newCellNumber(i1),1)];
    NominalBetaVec = [NominalBetaVec; NominalBetaVec(ind(i1))*ones(newCellNumber(i1),1)];
    Mcell = [Mcell; LOCALcreateNewCells(Mcell(ind(i1),:), newCellNumber(i1), opt)];
end

for i1 = 1:Ncomp
    [fnom{i1},fver{i1}] = getf(sys,Mcell(end-Ncomp+i1,:));
    prior(i1).Beta = Beta_vec(crsizeMcell+i1);
    prior(i1).Gamma = Gamma_vec(crsizeMcell+i1);
    prior(i1).V = Vvec(crsizeMcell+i1);
end

auxsize = size(Mcell,1) - crsizeMcell; 
UpB_vec = [UpB_vec; inf*ones(auxsize,1)];
    
    

%%-----------------------------------------------------------------------
function [newcells] =... 
              LOCALcreateNewCells(oldcell, N, opt)
      
m = length(oldcell)/2; 
Mcell = oldcell;
for i1 = 1:m
    if opt.BB.logToDiv(i1) ~= 0
        Mcell(2*i1-1) = opt.BB.logToDiv(i1)*log10(Mcell(2*i1-1));
        Mcell(2*i1) = opt.BB.logToDiv(i1)*log10(Mcell(2*i1));
    end
end
          
divs = LOCALgetdivisors(N);

for i1 = 1:length(divs)
    ntodiv = divs(i1);
    
    news = [];
    for i2 = 1:size(Mcell,1);
        del = reshape(Mcell(i2,:),2,m);
        [max_len,max_idx]=max(del(2,:)-del(1,:));
        
        aux = [];
        for i3 = 1:ntodiv
            delaux = del;
            delaux(1,max_idx) = del(1,max_idx)+(i3-1)*(del(2,max_idx)-del(1,max_idx))/ntodiv; 
            delaux(2,max_idx) = del(1,max_idx)+(i3)*(del(2,max_idx)-del(1,max_idx))/ntodiv; 
            aux = [aux; reshape(delaux,1,2*m)];
        end
        news = [news;aux];
        
    end
    Mcell = news;
end

for i2 = 1:size(Mcell,1)
    for i1 = 1:m
        if opt.BB.logToDiv(i1)~= 0
            Mcell(i2,2*i1-1) = 10^((Mcell(i2,2*i1-1))/opt.BB.logToDiv(i1));
            Mcell(i2,2*i1) = 10^((Mcell(i2,2*i1))/opt.BB.logToDiv(i1));
        end
    end
end

newcells = Mcell;
        
                

%%-----------------------------------------------------------------------
function divs = LOCALgetdivisors(m)

divs = [];

d = 2;
while m>1   
    while ~rem(m,d)
        divs = [divs; d];
        m = m/d;
    end
    d = d + 1;
end
     
divs = divs(end:-1:1);
