function [fnom,fver] = getf(sys,c)

d = []; g = [];

f = sys.f;

if isfield(sys,'delvector')
    d = sys.delvector;
end
if isfield(sys,'nonaffine')
    g = sys.nonaffine;
end





m = length(c)/2;
mpu = length(g);
del = reshape(c, 2, m);
del_nom = sum(del,1)/2;


fnom = f(:,1) + f(:,2:2+length(del_nom)-1)*del_nom';

for i1 = 1:mpu
    gval = peval(LocalSubPeval(g(i1),d,del_nom'),g(i1).coef,g(i1).deg);
    fnom = fnom + gval*f(:,m+1+i1);
end


fver = polynomial(zeros(size(f,1),2^m));
for i1=1:2^m,
    ver_idx = rem(floor((i1-1)*pow2(1-m:0)),2)+1;
    fver(:,i1) = f(:,1);
    for i2 = 1:m
        fver(:,i1) = fver(:,i1) + del(ver_idx(i2),i2)*f(:,i2+1);
        ver(i2,i1) = del(ver_idx(i2),i2);
    end
end

if ~isempty(g)
    
    [L,U] = PolyCoverNew(c,d,g);


    fv = [];
    for i0 = 1:2^m
        faux = repmat(fver(:,i0),1,2^mpu);
        for i1 = 1:2^mpu
            ver_idx = rem(floor((i1-1)*pow2(1-mpu:0)),2)+1;
            ver_idx = ver_idx - 1;
            for i2 = 1:mpu
                faux(:,i1) = faux(:,i1)  +...
                    ((ver_idx(i2)*U(1:end-1,i2)+(1-ver_idx(i2))*L(1:end-1,i2))'*ver(:,i0) +...
                                   ver_idx(i2)*U(end,i2) + (1-ver_idx(i2))*L(end,i2))*f(:,m+1+i2);
            end
        end
        fv = [fv faux];
    end
    fver = fv;
end


fver = cleanpoly(fver,1e-6);
fnom = cleanpoly(fnom,1e-6);





%--------------------------------------------------------
function outval = LocalSubPeval(g,d,inval)

for i1 = 1:length(g.varname)
   % XXX PJS 5/20/2009 Updated polynomial to allow cell string inputs
   %ind = find(eq(d,polynomial(1,1,g.varname(i1),[1 1]) ));
   ind = find(eq(d,polynomial(g.varname(i1)) ));
   outval(i1) = inval(ind);
end
outval = outval';
