function [xmin,xmax,ymin,ymax] = limitsLevelSet(V,x)

xmin = 0;
xmax = 0;
ymin = 0;
ymax = 0;

th = rand(20,1)*2*pi;
X = [];
for i1 = 1:length(th)
    X = [X [cos(th(i1)); sin(th(i1))]];
end
X = [X [1.39;-1.86]];

for i1 = 1:length(V)
    for i2 = 1:length(V{i1})
        Vcur = V{i1}(i2);
        pvar t
        for i3 = 1:length(th)
            aux = subs(1 - Vcur, [char(x(1)),char(x(2))],{t*X(1,i3),t*X(2,i3)});
            d = aux.maxdeg;
            [v,e] = poly2basis(aux,monomials(t,0:d));
            pt = double(roots(v));   
            pidx = find( abs(imag(pt)) <= 1e-8* abs(real(pt)) );
            pt = pt(pidx);
            if length(pt)
               Xaux = repmat(X(:,i3),1,length(pt))*diag(pt(:));
               xmax = max([xmax Xaux(1,:)]);
               xmin = min([xmin Xaux(1,:)]);
               ymax = max([ymax Xaux(2,:)]);
               ymin = min([ymin Xaux(2,:)]);
            end
        end
    end
end

% xmin = 1.5*xmin;
% xmax = 1.5*xmax;
% ymin = 1.5*ymin;
% ymax = 1.5*ymax;