function   [Vbest, Gammabest, Betabest, info] = preIter(V, fList, XList, roaconstr, opt, info)


d = opt.display.roaest;


[infoGamma, infoBeta] = LOCALgetgammabeta(V,fList,XList,roaconstr,opt);

if d
    if isfield(opt,'Vinitial')
        fprintf('Initial V gives Beta = %4.3f\n',double(infoBeta.Beta));
    else
        if opt.sim.flag
            fprintf('Initial V (from the cvx outer bnd) gives Beta = %4.3f\n',double(infoBeta.Beta));
        else
            fprintf('Initial V (from linerization) gives Beta = %4.3f\n',double(infoBeta.Beta));
        end
    end
end

if ~opt.sim.flag
    Gammabest = infoGamma.Gamma;
    Betabest = infoBeta.Beta;
end

infoGamBest = infoGamma;
infoBetBest = infoBeta;
Vbest = V;
info.preIterBest.gamma = infoGamma;
info.preIterBest.beta = infoBeta;
info.preIterBest.V = V;
info.preIter(1).getgamma = infoGamma;
info.preIter(1).getbeta = infoBeta;
info.preIter(1).V = V;

if opt.sim.flag

    stopp = 0;
    if (opt.sampleV.runtoNmax ~= 1) & (infoBetBest.Beta >= opt.sampleV.Factor*min([info.SimLFG.sim.BetaUB,opt.sim.BetaInit]))
        stopp = 1;
    end

    smpl = 0;

    i1 = 2;
    while i1 <= opt.sampleV.nofVs & stopp == 0
        smpl = 1;
        if d
            fprintf('------------------Begin sampling the cvx outer bound for V\n');
        end
        phivec = poly2basis(V,roaconstr.zV);
        [Vnew, PhiVecNew] = sampleForV( XList, fList, info.SimLFG.LP.A(:,1:end-1), info.SimLFG.LP.b, phivec, opt, roaconstr, 1);
        [infoGamma, infoBeta] = LOCALgetgammabeta(Vnew,fList,XList,roaconstr,opt);
        info.preIter(i1).getgamma = infoGamma;
        info.preIter(i1).getbeta = infoBeta;
        info.preIter(i1).V = Vnew;
        if double(infoBeta.Beta) > double(infoBetBest.Beta)
            infoGamBest = infoGamma;
            infoBetBest = infoBeta;
            Vbest = Vnew;
            info.preIterBest.gamma = infoGamma;
            info.preIterBest.beta = infoBeta;
            info.preIterBest.V = Vnew;
        end
        if (opt.sampleV.runtoNmax ~= 1) & (double(infoBetBest.Beta) >= opt.sampleV.Factor*min([info.SimLFG.sim.BetaUB,opt.sim.BetaInit]))
            stopp = 1;
        end
        if d
            fprintf('Best Beta from sampling the cvx outer bound is %4.3f\n',double(infoBetBest.Beta));
        end
        i1 = i1 + 1;
    end
    if d
        if smpl
            fprintf('------------------End sampling the cvx outer bound for V\n');
        end
    end
    Gammabest = double(infoGamBest.Gamma);
    Betabest = double(infoBetBest.Beta);
    if d
        fprintf('Pre-iteration V with Beta = %4.3f (Gamma = %4.3f) \n',Betabest,Gammabest);
    end
end
    
    
   %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%% 
    
 




function [infoGamma, infoBeta] = LOCALgetgammabeta(V,fList,XList,roaconstr,opt)
if opt.coordoptim.flag
    infoGamma = getgamma(V, fList, XList, roaconstr, opt.getgamma);
    infoBeta = getbeta(V, infoGamma.Gamma, XList, roaconstr,opt.getbeta);
else
    infoGamma = getgamma_Affine(V, fList, XList, roaconstr, opt, 0);
    infoBeta = getbeta_Affine(V, infoGamma.Gamma, XList, roaconstr, opt, 0);
end

        
        
    
    

