function [R2Out, sOut] = BisectionR2GivenV(f, h, x, W, V, Gamma, sBasis, OptBis, mu)

sOut = polynomial(0);
R2Out = 0;

R2Low = OptBis.R2Low;
R2High = OptBis.R2High;
R2tol = OptBis.R2Tol;

if R2Low>0
    R2 = R2Low;
    R2Low = 0;
else
    R2 = R2High/2;
end

while R2High - R2Low > R2tol    
    [isfeasp,s] = checkR2GivenV(f, h, x, W, V, R2, Gamma, sBasis, mu);
    if ~isfeasp
        R2High = R2;
    else
        R2Low = R2;
        R2Out = R2;
        sOut = s;
    end
    R2 = 0.5*(R2Low+R2High);
end

